﻿using System;
using System.Collections.Generic;

namespace UMK.WzorceStrukturalne
{
    class Znak
    {
        //stan wewnętrzny
        protected char litera;
        //protected ConsoleColor kolor; //--> przenosimy do stanu zewnętrznego

        public Znak(char litera/*, ConsoleColor kolor*/)
        {
            this.litera = litera;
            //this.kolor = kolor;
        }

        public void Wyświetl(ConsoleColor kolor)
        {
            ConsoleColor oryginalnyKolor = Console.ForegroundColor;
            Console.ForegroundColor = kolor;
            Console.Write(litera);
            Console.ForegroundColor = oryginalnyKolor;
        }
    }

    class FabrykaZnaków
    {
        Dictionary<char, Znak> magazyn = new Dictionary<char, Znak>();

        public Znak PobierzZnak(char litera)
        {
            if (magazyn.ContainsKey(litera)) return magazyn[litera];
            else
            {
                Znak znak = new Znak(litera);
                magazyn.Add(litera, znak);
                return znak;
            }
        }
    }
}